%define current_version 0.06.19

Summary: Stub proxy filesystem
Name: spfs
Version: %{current_version}
Release:        1%{?dist}
License: GPLv3
Group: System Environment/Base
URL: https://git.sw.ru/projects/VZS/repos/spfs/
Source0: %{name}-%{current_version}.tar.bz2
BuildRequires: autoconf
BuildRequires: automake
BuildRequires: fuse-devel
BuildRequires: libcap-devel
ExclusiveArch: x86_64

%description
Stub proxy filesystem for CRIU.

%prep
%setup -q

%build
autoreconf -fi
%configure
make %{?_smp_mflags}

%install
make install DESTDIR=$RPM_BUILD_ROOT

%clean
rm -rf $RPM_BUILD_ROOT

%files
%{_sbindir}/%{name}
%{_sbindir}/%{name}-client
%{_sbindir}/%{name}-manager

%changelog
* Mon Jun 27 2016 Stanislav Kinsburskiy <skinsbursky@virtuozzo.com> 0.06.19
 - processes: carry original process state during replacement
 - swapfd: Add debug print of used mapping (Kirill Tkhai <ktkhai@virtuozzo.com>)
 - swapfd: Pull SIGSTOP handling from criu (Kirill Tkhai <ktkhai@virtuozzo.com>)

* Fri Jun 24 2016 Stanislav Kinsburskiy <skinsbursky@virtuozzo.com> 0.06.18
 - manager: do not stat mountpoint in init_mount_info

* Thu Jun 23 2016 Stanislav Kinsburskiy <skinsbursky@virtuozzo.com> 0.06.17
 - replace: use context namespaces instead opening new in do_replace_resources
 - namespaces: treat ns_fds as const in set_namespaces
 - manager: ctx_ns_fds helper introduced
 - manager: close spfs namespaces upon deletion
 - trees: release fifo paths on trees destroy
 - processes: destroy processes object trees on release
 - processes: destroy processes objects on release
 - processes: release process maps in case of error
 - processes: release process fds in case of error
 - processes: pass fd_info_s to process_add_fd instead of it's parts
 - vz: fix process search in vz/nfs_test.sh
 - scripts: add more useful logic to nfs_test
 - processes: remove "unlinked" from fd_info_s as unused
 - autogen.sh: add "x" bit to owner

* Wed Jun 22 2016 Stanislav Kinsburskiy <skinsbursky@virtuozzo.com> 0.06.16
 - swap: fix root and cwd checks in do_swap_process_fs
 - replace: fix code execution in case of error in do_replace_resources

* Wed Jun 22 2016 Stanislav Kinsburskiy <skinsbursky@virtuozzo.com> 0.06.15
 - swapfd: remove redundant code pieces and debug
 - swap: pass file pos to swapfd routines
 - processes: collect file offset during fd parsing
 - manager: remove excessive debug
 - swapfd: format debug
 - manager: remove mappings collecting from swapfd.c
 - manager: remove unused code from swapfd.c
 - manager: use swam_map helper for mappings
 - manager: swap_map helper introduced
 - manager: collect all mapping attributes

* Tue Jun 21 2016 Stanislav Kinsburskiy <skinsbursky@virtuozzo.com> 0.06.14
 - manager: use new swap_{fds,maps,exe,cwd,root} helpers
 - manager: swap_{fds,maps,exe,cwd,root} helpers introduced
 - manager: remove debug print from get_fd_flags
 - vz: some improvements to nfs_test
 - swapfd: Do not force a change of mappings during fd change
 - swapfd: Print error message in case of memfd_create() fail

* Tue Jun 21 2016 Stanislav Kinsburskiy <skinsbursky@virtuozzo.com> 0.06.13
 - manager: split resources replacement into thre different functions
 - manager: remove obsolete and outdated fifo code
 - vz: make nfs_test.sh executable
 - vz: add additional cleanup after tests to nfs_test.sh
 - vz: improve test script output
 - vz: improve nfs test script

* Fri Jun 17 2016 Stanislav Kinsburskiy <skinsbursky@virtuozzo.com> 0.06.12
 - swapfd: Pull compat mode of parasite from criu

* Thu Jun 16 2016 Stanislav Kinsburskiy <skinsbursky@virtuozzo.com> 0.06.11
 - manager: provide O_CLOEXEC to fd swap routine
 - swapfd: Allow to fcntl::F_SETFD
 - swapfd: Check retval in change_fd()
 - vz: nfs_tests script added

* Wed Jun 15 2016 Stanislav Kinsburskiy <skinsbursky@virtuozzo.com> 0.06.10
 - utils: strip_deleted() helper introduced
 - manager: ressurect get_fd_flags and use it to obtain file flags
 - manager: improve error prints in files opening
 - manager: fix print typo in iterate_dir_name
 - spfs: improve gateway prints
 - spfs: do not remove xattrs for hidden files on file release
 - spfs: take link remap attribute into account when path is hidden
 - spfs: fix attrbutes comparison in find_xattr

* Wed Jun 15 2016 Stanislav Kinsburskiy <skinsbursky@virtuozzo.com> 0.06.9
 - spfs: fix debug print condition in spfs_getxattr
 - manager: colelct map file open from from /proc/<pid>/map_files

* Wed Jun 15 2016 Stanislav Kinsburskiy <skinsbursky@virtuozzo.com> 0.06.8
 - manager: teporary patch to fix fifo migration

* Fri Jun 10 2016 Stanislav Kinsburskiy <skinsbursky@virtuozzo.com> 0.06.7
 - manager: remove freezer open_cgroup_state helper
 - manager: cleanup resources replace helpers

* Fri Jun 10 2016 Stanislav Kinsburskiy <skinsbursky@virtuozzo.com> 0.06.6
 - manager: drop redundant "ns_list" option from mount command
 - manager: remove unused join_one_namespace helper
 - manager: use set_namespaces instead of join_namespaces
 - manager: replace spfs mounts without ct_run macro
 - manager: mount target wihtout using ct_run macro
 - manager: prepare and cleanup spfs environment by using join_spfs_context
 - manager: pass ns fds to __replace_resources
 - manager: join_spfs_context helper introduced
 - manager: split enter_spfs_context into namespaces and chroot parts
 - manager: move mount-related code to mount.c
 - manager: cleanup interface functions
 - namespaces: treat empty ns_mask as error in set_namespaces
 - namespaces: open namespaces with O_CLOEXEC
 - manager: create all spfs-related object in child on mount
 - manager: pass string agruments as consts to mount_spfs
 - manager: store init namespaces and pass to SPFS info structure
 - namespaces: remove unused change_namespaces helper
 - manager: store ns fds on spfs structure
 - processes: collect fd wisely
 - gateway: return spfs xattr if match
 - spfs: xattrs support introduced
 - list.h: include libio.h

* Thu Jun 09 2016 Stanislav Kinsburskiy <skinsbursky@virtuozzo.com> 0.06.5
 - processes: use fd_info_s contents in collect_process_fd
 - processe: get_fd_info helper inroduced
 - file object: discover process mode outside create_file_obj
 - processes: small cleanup to is_mnt_file
 - utils: unlinked_path helper introduced
 - spfs: do not treat gateway file operation result as error
 - spfs: handle only existent cur_wm in set_work_mode

* Tue Jun 07 2016 Stanislav Kinsburskiy <skinsbursky@virtuozzo.com> 0.06.4
 - processes: pass process info to is_mnt_file helper
 - pie-util-fd.h: include stdbool.h and include/ptrace.h
 - ptrace.h: drop bool declaration
 - processes: skip anonymous map examining
 - manager: infect processes right after seize
 - manager: seize processes before examining
 - processes: rename processes_collection_s into mounts_info_s
 - processes: collect_processes helper introduced
 - processes: rename collect_*_processes into examine_processes_by_*

* Mon Jun 06 2016 Stanislav Kinsburskiy <skinsbursky@virtuozzo.com> 0.06.3
 - manager: collect process root path string
 - swapfd: Use transfer_local_fd() in change_cwd()
 - swapfd: Chroot after chdir on given cwd
 - swapfd: Implement and use transfer_local_fd()
 - swapfd: Implement fchdir_seized()
 - swapfd: Implement close_seized()
 - swapfd: Export set_parasite_ctl() and destroy_parasite_ctl()
 - swapfd: Fully support seized send_fd() and recv_fd()
 - swapfd: Implement sendmsg_seized() and recvmsg_seized()
 - swapfd: Refactor recv_fd()
 - swapfd: Refactor send_fd()
 - swapfd: Cleanup: use mmap_seized()
 - swapfd: Bind local socket
 - swapfd: Cleanup rename parasite_ctl::addr{,len} to remote_addr{,len}
 - swapfd: Add chroot support

* Fri Jun 03 2016 Stanislav Kinsburskiy <skinsbursky@virtuozzo.com> 0.06.2
 - manager: mount spfs with "-o no_remote_lock"

* Wed Jun 01 2016 Stanislav Kinsburskiy <skinsbursky@virtuozzo.com> 0.06.1
 - manager: fix typo in error print in prepare_mount_env_ct

* Wed Jun 01 2016 Stanislav Kinsburskiy <skinsbursky@virtuozzo.com> 0.06.1
 - manager: fix typo in error print in prepare_mount_env_ct

* Tue May 31 2016 Stanislav Kinsburskiy <skinsbursky@virtuozzo.com> 0.06.0
 - manager: print fd open flags in collect_process_fd
 - manager: collect fifo file to avoid multiple content restore
 - manager: collect_fifo() helper introduced
 - manager: "fill" callback for fifo introduced
 - manager: remove get_target_fd() helper
 - manager: fifo file object added
 - manager: "file object" introduced
 - soruces: move namespace code to src/namespaces.c

* Mon May 30 2016 Stanislav Kinsburskiy <skinsbursky@virtuozzo.com> 0.05.3
 - manager: move process need replace check to separated function

* Mon May 30 2016 Stanislav Kinsburskiy <skinsbursky@virtuozzo.com> 0.05.2
 - manager: improve debug output
 - util: simplify create_dir helper
 - manager: toss fd open code a bit
 - print: print_on_level_ts introduced
 - print: remove print_on_level_va declaration
 - manager: check either process is kthread in actor instead of loop
 - manager: try to find search fd table before fd collecting

* Fri May 27 2016 Stanislav Kinsburskiy <skinsbursky@virtuozzo.com> 0.05.1
 - manager: collect map fd which parsing processes info
 - manager: map fd tree introduced
 - manager: collect map files via /proc/<pid>/maps
 - manager: split read link and actual fix of the path to open
 - manager: fix print typo in iterate_pids_list_name

* Fri May 27 2016 Stanislav Kinsburskiy <skinsbursky@virtuozzo.com> 0.05.0
 - manager: ignore collect process fs struct is shared
 - manager: fs tree introduced
 - manager: split collecting of process struct fs and exe
 - manager: split process_env into fs struct and exe fd
 - manager: do not collect process files if fd table is shared
 - manager: fd table tree introduced
 - manager: move kcmp code to separated helper kcmp()
 - manager: set 10 sec timeout for freezer and print in case of timed out
 - manager: rename add_fd_to_tree into collect_process_fd
 - manager: rename fd_tree.* into trees.*
 - manager: include list.h into processes.h
 - manager: rename root into fd_tree_root in fd_tree.c
 - manager: unmount source mountpoint right after replacement and redirecting
 - futex: fix wrong treatment of syscall(SYS_futex, ...) result
 - futex: return 0 from futex_wake in case of success
 - manager: "replace" mode introduced
 - spfs: use futex helpers instead of plain syscall in mode change helpers
 - sources: futex-related operation moved to src/futex.c
 - manager: move spfs creation into create_spfs_info helper

* Thu May 26 2016 Stanislav Kinsburskiy <skinsbursky@virtuozzo.com> 0.04.0
 - manager: do not collect process files if fd table is shared
 - manager: fd table tree introduced
 - manager: move kcmp code to separated helper kcmp()
 - manager: set 10 sec timeout for freezer and print in case of timed out
 - manager: rename add_fd_to_tree into collect_process_fd
 - manager: rename fd_tree.* into trees.*
 - manager: include list.h into processes.h
 - manager: rename root into fd_tree_root in fd_tree.c
 - manager: unmount source mountpoint right after replacement and redirecting
 - futex: fix wrong treatment of syscall(SYS_futex, ...) result
 - futex: return 0 from futex_wake in case of success
 - manager: "replace" mode introduced
 - spfs: use futex helpers instead of plain syscall in mode change helpers
 - sources: futex-related operation moved to src/futex.c
 - manager: move spfs creation into create_spfs_info helper

* Wed May 25 2016 Stanislav Kinsburskiy <skinsbursky@virtuozzo.com> 0.03.2
 - manager: unmount source mountpoint right after replacement and redirecting
 - futex: fix wrong treatment of syscall(SYS_futex, ...) result
 - futex: return 0 from futex_wake in case of success
 - manager: "replace" mode introduced
 - spfs: use futex helpers instead of plain syscall in mode change helpers
 - sources: futex-related operation moved to src/futex.c
 - manager: move spfs creation into create_spfs_info helper

* Wed May 25 2016 Stanislav Kinsburskiy <skinsbursky@virtuozzo.com> 0.03.1
 - futex: fix wrong treatment of syscall(SYS_futex, ...) result
 - futex: return 0 from futex_wake in case of success
 - manager: "replace" mode introduced
 - spfs: use futex helpers instead of plain syscall in mode change helpers
 - sources: futex-related operation moved to src/futex.c
 - manager: move spfs creation into create_spfs_info helper

* Wed May 25 2016 Konstantin Volkov <wolf@virtuozzo.com> 0.03.0
 - manager: reopen freezer state file on each state check (Stanislav Kinsburskiy
<skinsbursky@virtuozzo.com>)
 - manager: trim '\n" from current freezer state in freezer_set_state (Stanislav
Kinsburskiy <skinsbursky@virtuozzo.com>)
 - manager: return actual result in spfs_freeze_and_lock (Stanislav Kinsburskiy
<skinsbursky@virtuozzo.com>)
 - manager: try to rollback freezer state in case of set error (Stanislav
Kinsburskiy <skinsbursky@virtuozzo.com>)
 - manager: wait for freeze cgroup changed the state (Stanislav Kinsburskiy
<skinsbursky@virtuozzo.com>)
 - manager: freeze processes in replace_resources (Stanislav Kinsburskiy
<skinsbursky@virtuozzo.com>)
 - manager: convert mount paths to canonical view (Stanislav Kinsburskiy
<skinsbursky@virtuozzo.com>)
 - manager: open map file with correct access mode (Stanislav Kinsburskiy
<skinsbursky@virtuozzo.com>)
 - manager: adjust patch by source mount in is_mnt_fd (Stanislav Kinsburskiy
<skinsbursky@virtuozzo.com>)
 - manager: fix strsep usage (Stanislav Kinsburskiy <skinsbursky@virtuozzo.com>)
 - manager: do not try to manage namepaces without pid (Stanislav Kinsburskiy
<skinsbursky@virtuozzo.com>)
 - manager: "switch" command added to interface (Stanislav Kinsburskiy
<skinsbursky@virtuozzo.com>)
 - manager: make repalce fully independent from spfs internals (Stanislav
Kinsburskiy <skinsbursky@virtuozzo.com>)
 - manager: cleanup and rename processes fd info (Stanislav Kinsburskiy
<skinsbursky@virtuozzo.com>)
 - manager: move all spfs-related code to spfs.c (Stanislav Kinsburskiy
<skinsbursky@virtuozzo.com>)
 - manager: make replace interfaces more abstract (Stanislav Kinsburskiy
<skinsbursky@virtuozzo.com>)
 - manager: move cgroup pids read routine to freeze.c (Stanislav Kinsburskiy
<skinsbursky@virtuozzo.com>)
 - manager: untie processes info from spfs (Stanislav Kinsburskiy
<skinsbursky@virtuozzo.com>)
 - manager: "mount" object introduced (Stanislav Kinsburskiy
<skinsbursky@virtuozzo.com>)
 - manager: rename mount.{c,h} into replace.{c.h} (Stanislav Kinsburskiy
<skinsbursky@virtuozzo.com>)
 - manager: set SIG_CHLD handle to SIG_DFL in mount replace handler (Stanislav
Kinsburskiy <skinsbursky@virtuozzo.com>)

* Thu May 19 2016 Stanislav Kinsburskiy <skinsbursky@virtuozzo.com> 0.02.2
 - manager: lazily unmount spfs working directory
 - manager: do not close fd in move_to_cgroup_fd

* Thu May 19 2016 Stanislav Kinsburskiy <skinsbursky@virtuozzo.com> 0.02.1
 - manager: do not close fd in move_to_cgroup_fd

* Thu May 19 2016 Stanislav Kinsburskiy <skinsbursky@virtuozzo.com> 0.02.0
 - Makefile: make swapfd "noinst" program
 - spec: fix repo path

* Thu May 19 2016 Stanislav Kinsburskiy <skinsbursky@virtuozzo.com> 0.01.5
 - sources: remove spfs-change-mode.sh
 - spec: fix repo path

* Wed May 18 2016 Stanislav Kinsburskiy <skinsbursky@virtuozzo.com> 0.01.4
 - manager: try to unmount spfs working directory few times before give up

* Mon May 16 2016 Andrey Bondrov <abondrov@virtuozzo.com> 0.01-2
- Add swapfd and spfs-change-mode.sh to package files

* Wed May 04 2016 Andrey Bondrov <abondrov@virtuozzo.com> 0.01-1
- Initial package
